;
; Pavlushin Evgeni port 3dtest to MenuetOS
; mail: waptap@mail.ru       site: www.deck4.narod.ru
;
; Mikolaj Felix 25/5/2001
; mfelix@polbox.com
;

use32
               org     0x0
               db     'MENUET01'              ; 8 byte id
               dd     0x01                    ; header version
               dd     START                   ; start of code
               dd     I_END                   ; size of image
               dd     0x300000                 ; memory for app
               dd     0x300000                ; esp
               dd     0x0 , 0x0               ; I_Param , I_Icon

MAX_POINTS equ 8
MAX_FACES equ 12

START:
   	call init_sin_cos

still:
    mov eax,23  ; wait for system event with 10 ms timeout
    mov ebx,1   ; wait 10 ms, then continue
    int  0x40

    cmp eax,0
    je main_loop
    cmp  eax,1                  ; window redraw request ?
    je   red
    cmp  eax,2                  ; key in buffer ?
    je   key
    cmp  eax,3                  ; button in buffer ?
    je   button


;	mov ax,13h
;	int 10h

main_loop:
	mov esi,object
	mov edi,object_rotated
	mov ecx,MAX_POINTS*3
	cld
	rep movsw

	mov esi,angle_x
	mov edi,object_rotated
	mov ecx,MAX_POINTS
	call rotate_points

	mov esi,object_rotated
	mov edi,object_translated
	mov ecx,MAX_POINTS
	call translate_points

	call draw_faces

	call clear_screen_buffer

	add [angle_x],2
	add [angle_y],3
	add [angle_z],1

;	in al,60h
;	cmp al,1
;	jne main_loop

;	mov ax,03h
;	int 10h
;	mov ax,4c00h
;	int 21h

     jmp still

red:
     call draw_window
     jmp still
key:
     mov eax,2
     int 0x40
     jmp still
button:
     mov eax,17
     int 0x40
     cmp ah,1
     jne still
exit:
     mov eax,-1
     int 0x40

;Draw window
draw_window:
    mov eax,12  ;Start
    mov ebx,1
    int 0x40

    mov eax,0   ;Draw window
    mov ebx,200*65536+(320+10) ;x start*65536+x size
    mov ecx,200*65536+(240+30) ;y start*65536+y size
    mov edx,0x03000000         ;0x03 use skinned window
    int 0x40

    mov eax,4   ;Out Text
    mov ebx,8*65536+8          ;x start*65536+y start
    mov ecx,0x00ffffff         ;color White
    mov edx,head_label
    mov esi,hl_end-head_label
    int 0x40

    mov eax,12  ;End
    mov ebx,2
    int 0x40
    ret

head_label: db "3D TEST SAMPLE FOR MENUETOS"
hl_end:



; Draw faces procedure

@@dx1 dw 0
@@dy1 dw 0
@@dx2 dw 0
@@dy2 dw 0
@@dx3 dw 0
@@dy3 dw 0

draw_faces:

	mov esi,link
	mov ecx,MAX_FACES
df_draw:
	push ecx
	mov ecx,3
	mov edi,@@dx1 ;bp
df_get_point:
	xor bh,bh
	mov bl,byte [esi]
	shl bx,2
	mov ax,word [object_translated+bx]
	mov word [edi],ax
	mov ax,word [object_translated+bx+2]
	mov word [edi+2],ax
	inc esi
	add edi,4
	dec ecx
	jnz df_get_point

	mov ax,[@@dy1]
	sub ax,[@@dy3]
	mov bx,[@@dx2]
	sub bx,[@@dx1]
	imul bx
	shl edx,16
	mov dx,ax
	push edx
	mov ax,[@@dx1]
	sub ax,[@@dx3]
	mov bx,[@@dy2]
	sub bx,[@@dy1]
	imul bx
	shl edx,16
	mov dx,ax
	pop ebx
	sub ebx,edx
	or ebx,ebx
	jge df_next

	xor ah,ah
	mov al,byte [si]
	
     mov  [@@xcol],ax
     mov  ax,[@@dx1]
     mov  [@@tx1],ax
     mov  ax,[@@dy1]
     mov  [@@ty1],ax
     mov  ax,[@@dx2]
    	mov  [@@tx2],ax
     mov  ax,[@@dy2]
     mov  [@@ty2],ax
     mov  ax,[@@dx3]
    	mov  [@@tx3],ax
     mov  ax,[@@dy3]
     mov  [@@ty3],ax


	call filled_triangle
df_next:
	inc si
	pop ecx
	dec ecx
	jnz df_draw
	ret

;include graphlib.asm
; Mikolaj Felix 9/12/2000
; mfelix@polbox.com

clear_screen_buffer:
;	push es
;	mov ax,0a000h
;	mov es,ax ;buffer_seg
;	xor di,di
;	xor eax,eax
;	mov cx,16000
;	cld
;	rep stosd
;	pop es

 mov ebx,10
 mov eax,5
 int 0x40

 mov ebx,0*65536+500
 mov ecx,0*65536+500
 mov edx,0x00000000

 mov eax,13
 int 0x40
	ret

;include triangle.asm
; Mikolaj Felix 14/5/2001
; mfelix@polbox.com

;filled trangle procedure

@@tx1  dw 0
@@ty1  dw 0
@@tx2  dw 0
@@ty2  dw 0
@@tx3  dw 0
@@ty3  dw 0
@@xcol dw 0

@@dx12 dw 0
@@dx13 dw 0
@@dx23 dw 0

filled_triangle:

;	push es
; mov ax,0a000h
;	mov es,ax ;buffer_seg

 mov eax,0
	mov ax,[@@ty1]
	cmp ax,[@@ty3]
	jb ft_check1

	xchg ax,[@@ty3]
	mov [@@ty1],ax

 mov eax,0
	mov ax,[@@tx1]
	xchg ax,[@@tx3]
	mov [@@tx1],ax
ft_check1:
 mov eax,0
	mov ax,[@@ty2]
	cmp ax,[@@ty3]
	jb ft_check2

	xchg ax,[@@ty3]
	mov [@@ty2],ax

 mov eax,0
	mov ax,[@@tx2]
	xchg ax,[@@tx3]
	mov [@@tx2],ax
ft_check2:
 mov eax,0
	mov ax,[@@ty1]
	cmp ax,[@@ty2]
	jb ft_check3

	xchg ax,[@@ty2]
	mov [@@ty1],ax

 mov eax,0
	mov ax,[@@tx1]
	xchg ax,[@@tx2]
	mov [@@tx1],ax
ft_check3:

 mov ebx,0
	mov bx,[@@ty2]
	sub bx,[@@ty1]
	jnz ft_dx12_make

	mov [@@dx12],word 0
	jmp ft_dx12_done
ft_dx12_make:
 mov eax,0
	mov ax,[@@tx2]
	sub ax,[@@tx1]
	shl ax,7
	cwd
	idiv bx
	mov [@@dx12],ax			; dx12 = (x2-x1)/(y2-y1)
ft_dx12_done:

 mov ebx,0
	mov bx,[@@ty3]
	sub bx,[@@ty1]
	jnz ft_dx13_make

	mov [@@dx13],word 0
	jmp ft_dx13_done
ft_dx13_make:
 mov eax,0
	mov ax,[@@tx3]
	sub ax,[@@tx1]
	shl ax,7
	cwd
	idiv bx
	mov [@@dx13],ax			; dx13 = (x3-x1)/(y3-y1)
ft_dx13_done:

 mov ebx,0
	mov bx,[@@ty3]
	sub bx,[@@ty2]
	jnz ft_dx23_make

	mov [@@dx23],word 0
	jmp ft_dx23_done
ft_dx23_make:
 mov eax,0
	mov ax,[@@tx3]
	sub ax,[@@tx2]
	shl ax,7
	cwd
	idiv bx
	mov [@@dx23],ax			; dx23 = (x3-x2)/(y3-y2)
ft_dx23_done:

 mov eax,0
	mov ax,[@@tx1]
	shl ax,7
	mov bx,ax

 mov ecx,0
	mov cx,[@@ty1]
ft_loop1:
;	push eax
;	push ecx
 pushad

	mov [@@ly],cx
	mov dx,bx
	shr dx,7
	mov [@@lx2],dx
	mov dx,ax
	shr dx,7
	mov [@@lx1],dx
	mov ax,[@@xcol]
 mov [@@lcol],ax
 call horizontal_line

;	pop ecx
;	pop eax
 popad

	add ax,[@@dx13]
	add bx,[@@dx12]
	inc cx
	cmp cx,[@@ty2]
	jb ft_loop1

	
	mov bx,[@@tx2]
	shl bx,7
	mov cx,[@@ty2]
ft_loop2:
;	push eax
;	push ecx
 pushad

	mov [@@ly],cx
	mov dx,bx
	shr dx,7
	mov [@@lx2],dx
	mov dx,ax
	shr dx,7
	mov [@@lx1],dx
 mov ax,[@@xcol]
 mov [@@lcol],ax
	call horizontal_line

 popad
;	pop ecx
;	pop eax

	add ax,[@@dx13]
	add bx,[@@dx23]
	inc ecx
	cmp cx,[@@ty3]
	jb ft_loop2

;	pop es
	ret

;horizontal line subproc

@@lx1  dw 0
@@lx2  dw 0
@@ly   dw 0
@@lcol dw 0

horizontal_line:

;	push bp

;	mov ax,[@@lx1]
;	cmp ax,[@@lx2]
;	je hl_quit
;	jb hl_ok

;	xchg ax,[@@lx2]
;	mov [@@lx1],ax
;hl_ok:
;	mov di,[@@ly]
;	mov ax,di
;	shl di,6
;	shl ax,8
;	add di,ax
;	add di,[@@lx1]

;	mov ax,[@@lcol]
;	mov ah,al

;	cld
;	mov cx,[@@lx2]
;	sub cx,[@@lx1]
;	inc cx
;	shr cx,1
;	jnc hl_draw
;	stosb
;hl_draw:
;	rep stosw
;hl_quit:
; ret

;	pop bp

; mov ebx,0
; mov ecx,0
; mov bx,[@@lx1]
; mov cx,[@@ly]
; mov edx,0x00ff00ff
; mov eax,1
; int 0x40

; mov ebx,0
; mov ecx,0
; mov bx,[@@lx2]
;; sub bx,[@@lx1]
; mov cx,[@@ly]
; mov edx,0x00ff00ff
; mov eax,1
; int 0x40

; ret

 mov eax,0
 mov ax,[@@lx1]
 mov ebx,eax
 shl ebx,16
 mov eax,0
 mov ax,[@@lx2]
; sub ax,[@@lx1]
; shr ax,2
; shr ax,9
 add ebx,eax

 mov eax,0
 mov ax,[@@ly]
 mov ecx,eax
 shl ecx,16
 add ecx,eax

 mov eax,0
 mov ax,[@@lcol]
 shl eax,8
 mov ax,[@@lcol]
 shl eax,8
 mov ax,[@@lcol]
 shl eax,8
 mov edx,eax

 mov eax,38 ;13
 int 0x40
	ret

;include fixed3d.asm
; Mikolaj Felix 25/5/2001
; mfelix@polbox.com

;------------------------------------------------------------
;	ds:si	- offset to angles
;	ds:di	- offset to 3d points
;	cx	- number of points
;------------------------------------------------------------

@@sin_x dw 0
@@cos_x dw 0
@@sin_y dw 0
@@cos_y dw 0
@@sin_z dw 0
@@cos_z dw 0

@@px equ word [edi]
@@py equ word [edi+2]
@@pz equ word [edi+4]

rotate_points:

 push edi
	mov edi,@@sin_x
	mov edx,3
rp_sin_cos:
	mov bx,word [esi]
	and bx,511
	shl bx,1
	mov ax,word [sin_table+bx]
	mov word [edi],ax
	mov ax,word [cos_table+bx]
	mov word [edi+2],ax

	add esi,2
	add edi,4
	dec edx
	jnz rp_sin_cos
	pop edi

rp_rotate:

	; rotate around x-axis

	mov ax,@@py
	imul [@@cos_x]
	mov bx,ax
	mov si,dx

	mov ax,@@pz
	imul [@@sin_x]
	sub bx,ax
	sbb si,dx
	shrd bx,si,14
	push bx

	mov ax,@@py
	imul [@@sin_x]
	mov bx,ax
	mov si,dx

	mov ax,@@pz
	imul [@@cos_x]
	add bx,ax
	adc si,dx
	shrd bx,si,14

	pop @@py
	mov @@pz,bx

	; rotate around y-axis

	mov ax,@@px
	imul [@@cos_y]
	mov bx,ax
	mov si,dx

	mov ax,@@pz
	imul [@@sin_y]
	sub bx,ax
	sbb si,dx
	shrd bx,si,14
	push bx

	mov ax,@@px
	imul [@@sin_y]
	mov bx,ax
	mov si,dx

	mov ax,@@pz
	imul [@@cos_y]
	add bx,ax
	adc si,dx
	shrd bx,si,14

	pop @@px
	mov @@pz,bx

	; rotate around z-axis

	mov ax,@@px
	imul [@@cos_z]
	mov bx,ax
	mov si,dx

	mov ax,@@py
	imul [@@sin_z]
	sub bx,ax
	sbb si,dx
	shrd bx,si,14
	push bx

	mov ax,@@px
	imul [@@sin_z]
	mov bx,ax
	mov si,dx

	mov ax,@@py
	imul [@@cos_z]
	add bx,ax
	adc si,dx
	shrd bx,si,14

	pop @@px
	mov @@py,bx

	add edi,6
	dec ecx
	jnz rp_rotate

	ret

;------------------------------------------------------------
;	ds:si	- offset to 3d points
;	es:di	- offset to 2d points
;	cx	- number of points
;------------------------------------------------------------

translate_points:
	mov bx,word [esi+4]
	add bx,256

	mov ax,word [esi]
	shl ax,8
	cwd
	idiv bx
	add ax,160
	stosw

	mov ax,word [esi+2]
	shl ax,8
	cwd
	idiv bx
	add ax,100
	stosw

	add esi,6
	dec ecx
	jnz translate_points
	ret

init_sin_cos:
	finit
	fldz
	fstp [temp]
	xor edi,edi
	mov ecx,512
isc_make:
	fld [temp]
	fld st0
	fld st0
	fsin
	fmul [fixed_point_const]
	fistp word [sin_table+edi]
	fcos
	fmul [fixed_point_const]
	fistp word [cos_table+edi]

	fadd [inc_angle]
	fstp [temp]

	add edi,2
	loop isc_make
	ret

temp dd 0

fixed_point_const dd 16384.0
inc_angle dd 0.01227184630309			; pi/256

sin_table:
times 512 dw 0
cos_table:
times 512 dw 0

;MAX_POINTS equ 8
;MAX_FACES equ 12

angle_x dw 0
angle_y dw 0
angle_z dw 0

object	dw -50,-50,-50, 50,-50,-50, 50,50,-50, -50,50,-50
	dw -50,-50,50, 50,-50,50, 50,50,50, -50,50,50

link	db 0,1,2,45, 0,2,3,45, 5,4,7,32, 5,7,6,32, 1,5,6,40, 1,6,2,40
	db 4,0,3,80, 4,3,7,80, 4,5,1,60, 1,0,4,60, 3,2,6,94, 3,6,7,94

object_rotated:
times MAX_POINTS dw 0,0,0
object_translated:
times MAX_POINTS dw 0,0

I_END: